#ifndef DEQUE_H
#define DEQUE_H

template <typename T> class deque {
 public:
  deque(int cap);
  ~deque();
  void adicionaNoFim(const T & arg);
  void adicionaNoInicio(const T & arg);
  T retiraDoFim();
  T retiraDoInicio();
  T & frente() const;
  T & traseira() const;
  bool vazia() const { return itens == 0;}
  bool cheia() const { return itens == capacidade;}
  int comprimento() const {return itens;}
 private:
  int inicio, fim, itens, capacidade;
  T * buffer;
};

template <typename T> deque<T>::deque(int cap) {
  capacidade = cap;
  itens = 0;
  inicio = 0;
  fim = 0;
  buffer = new T[capacidade];
}

template <typename T> deque<T>::~deque() {
  delete[] buffer;
}

template <typename T> void deque<T>::adicionaNoFim(const T & arg) {
  if (cheia()) throw -1;
  buffer[fim] =  arg;
  fim=(fim+1)%capacidade;
  itens++;
}

template <typename T> void deque<T>::adicionaNoInicio(const T & arg) {
  if (cheia()) throw -1;
  inicio = (inicio -1 + capacidade) % capacidade;
  buffer[inicio] =  arg;
  itens++;
}

template <typename T> T deque<T>::retiraDoInicio() {
  if (vazia()) throw -1;
  int pos = inicio;
  inicio = (inicio+1) % capacidade;
  itens--;
  return buffer[pos];
}

template <typename T> T deque<T>::retiraDoFim() {
  if (vazia()) throw -1;
  fim = (fim-1+capacidade) % capacidade;
  itens--;
  return buffer[fim];
}

template <typename T> T & deque<T>::frente() const {
  if (vazia()) throw -1;
  return buffer[inicio];
}

template <typename T> T & deque<T>::traseira() const {
  if (vazia()) throw -1;
  return buffer[(fim-1+capacidade)%capacidade];
}

#endif
